# SimpleRsBLE

The ultimate cross-platform library and bindings for Bluetooth Low Energy (BLE), designed for simplicity and ease of use.

**IMPORTANT:** SimpleRsBLE has a new API! Check it out and leave your feedback!

## Key Features

* **Cross-Platform**: Enterprise-grade support for Windows, macOS, Linux, iOS, and Android
* **Easy Integration**: Clean, consistent API across all platforms
* **Multiple Language Bindings**: Production-ready bindings for C, C++, Python, Java and Rust, with more coming soon
* **Commercial Ready**: Source-available commercial license for proprietary applications

## Support & Resources

We're here to help you succeed with SimpleBLE:

* **Documentation**: Visit our [ReadTheDocs](https://simpleble.readthedocs.io/en/latest/) page for comprehensive guides
* **Commercial Support**: Check our [our website](https://simpleble.org?utm_source=crates_io&utm_medium=referral&utm_campaign=simplersble_readme) or [email us](mailto:contact@simpleble.org) about licensing and professional services
* **Community**: Join our [Discord](https://discord.gg/N9HqNEcvP3) server for discussions and help

**Don't hesitate to reach out if you need assistance - we're happy to help!**

## Installation

You can add SimpleRsBLE to your project by adding the following lines to your `Cargo.toml`:

```toml
[dependencies]
simplersble = "0.10.1"
```

Please review our [code examples](https://github.com/simpleble/simpleble/tree/main/examples/simplersble/src/bin) on GitHub for more information on how to use SimpleRsBLE.

# License

Since January 20th 2025, SimpleBLE is now available under the Business Source License 1.1 (BUSL-1.1). Each
version of SimpleBLE will convert to the GNU General Public License version 3 after four years of its initial release.

The project is free to use for non-commercial purposes, but requires a commercial license for commercial use. We
also offer FREE commercial licenses for small projects and early-stage companies - reach out to discuss your use case!

**Why purchase a commercial license?**

- Build and deploy unlimited commercial applications
- Use across your entire development team
- Zero revenue sharing or royalty payments
- Choose features that match your needs and budget
- Priority technical support included
- Clear terms for integrating into MIT-licensed projects

**Looking for information on pricing and commercial terms of service?** Visit [our website](https://simpleble.org?utm_source=crates_io&utm_medium=referral&utm_campaign=simplersble_readme) for more details.

For further enquiries, please [email us](mailto:contact@simpleble.org) or [leave us a message on our website](https://www.simpleble.org/contact?utm_source=crates_io&utm_medium=referral&utm_campaign=simplersble_readme) and we can discuss the specifics of your situation.

---

**SimpleBLE** is a project powered by [**The California Open Source Company**](https://californiaopensource.com?utm_source=crates_io&utm_medium=referral&utm_campaign=simplersble_readme).